'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.moleculeSelectDropdownListSizes = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactMoleculeDropdownList = require('@s-ui/react-molecule-dropdown-list');

var _SingleSelection = require('./components/SingleSelection');

var _SingleSelection2 = _interopRequireDefault(_SingleSelection);

var _MultipleSelection = require('./components/MultipleSelection');

var _MultipleSelection2 = _interopRequireDefault(_MultipleSelection);

var _hoc = require('@s-ui/hoc');

var _react3 = require('@s-ui/js/lib/react');

var _dom = require('@s-ui/js/lib/dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-MoleculeSelect';
var CLASS_FOCUS = BASE_CLASS + '--focus';

var ERROR_STATES = {
  ERROR: 'error',
  SUCCESS: 'success'
};

var MoleculeSelect = function (_Component) {
  (0, _inherits3.default)(MoleculeSelect, _Component);

  function MoleculeSelect() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, MoleculeSelect);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MoleculeSelect.__proto__ || (0, _getPrototypeOf2.default)(MoleculeSelect)).call.apply(_ref, [this].concat(args))), _this), _this.refMoleculeSelect = _this.props.refMoleculeSelect || _react2.default.createRef(), _this.refsMoleculeSelectOptions = [], _this.state = {
      focus: false
    }, _this.closeList = function (ev) {
      var onToggle = _this.props.onToggle;
      var _this2 = _this,
          domMoleculeSelect = _this2.refMoleculeSelect.current;

      onToggle(ev, { isOpen: false });
      domMoleculeSelect.focus();
      ev.preventDefault();
      ev.stopPropagation();
    }, _this.focusFirstOption = function (ev, _ref2) {
      var options = _ref2.options;

      options[0].focus();
      ev.preventDefault();
      ev.stopPropagation();
    }, _this.handleToggle = function (ev) {
      var onToggle = _this.props.onToggle;

      onToggle(ev, {});
      ev.preventDefault();
      ev.stopPropagation();
    }, _this.handleKeyDown = function (ev) {
      ev.persist();
      var isOpen = _this.props.isOpen;
      var _this3 = _this,
          refMoleculeSelect = _this3.refMoleculeSelect,
          refsMoleculeSelectOptions = _this3.refsMoleculeSelectOptions,
          closeList = _this3.closeList,
          focusFirstOption = _this3.focusFirstOption,
          handleToggle = _this3.handleToggle;


      var options = refsMoleculeSelectOptions.map(_react3.getTarget);
      var domSourceEvent = ev.target;
      var domMoleculeSelect = refMoleculeSelect.current;
      if (!isOpen) {
        if (['Enter', 'ArrowDown', 'ArrowUp'].includes(ev.key)) {
          if (domSourceEvent === domMoleculeSelect) handleToggle(ev);else closeList(ev);
        }
      } else {
        var currentElementFocused = (0, _dom.getCurrentElementFocused)();
        var isSomeOptionFocused = [].concat((0, _toConsumableArray3.default)(options)).includes(currentElementFocused);
        if (ev.key === 'Escape') closeList(ev);
        if (ev.key === 'ArrowDown' && !isSomeOptionFocused) focusFirstOption(ev, { options: options });
      }
    }, _this.handleSelect = function () {
      _this.setState({ focus: true });
    }, _this.handleFocusIn = function () {
      _this.setState({ focus: true });
    }, _this.handleFocusOut = function (ev) {
      ev.persist();
      var _this4 = _this,
          refsMoleculeSelectOptions = _this4.refsMoleculeSelectOptions,
          closeList = _this4.closeList;
      var isOpen = _this.props.isOpen;

      var options = refsMoleculeSelectOptions.map(_react3.getTarget);
      setTimeout(function () {
        var currentElementFocused = (0, _dom.getCurrentElementFocused)();
        var isSomeOptionFocused = [].concat((0, _toConsumableArray3.default)(options)).includes(currentElementFocused);
        if (!isSomeOptionFocused && isOpen) {
          closeList(ev);
        }
      }, 1);
      _this.setState({ focus: false });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(MoleculeSelect, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          multiselection = _props2.multiselection,
          _props = (0, _objectWithoutProperties3.default)(_props2, ['multiselection']);

      var className = this.className,
          handleKeyDown = this.handleKeyDown,
          extendedChildren = this.extendedChildren,
          refMoleculeSelect = this.refMoleculeSelect,
          handleFocusIn = this.handleFocusIn,
          handleFocusOut = this.handleFocusOut;


      return _react2.default.createElement(
        'div',
        {
          ref: refMoleculeSelect,
          tabIndex: '0',
          className: className,
          onKeyDown: handleKeyDown,
          onFocus: handleFocusIn,
          onBlur: handleFocusOut
        },
        multiselection ? _react2.default.createElement(
          _MultipleSelection2.default,
          (0, _extends3.default)({
            refMoleculeSelect: refMoleculeSelect
          }, _props),
          extendedChildren
        ) : _react2.default.createElement(
          _SingleSelection2.default,
          (0, _extends3.default)({
            refMoleculeSelect: refMoleculeSelect
          }, _props),
          extendedChildren
        )
      );
    }
  }, {
    key: 'extendedChildren',
    get: function get() {
      var _props3 = this.props,
          children = _props3.children,
          keysSelection = _props3.keysSelection; // eslint-disable-line react/prop-types

      var refsMoleculeSelectOptions = this.refsMoleculeSelectOptions;

      return _react2.default.Children.toArray(children).filter(Boolean).map(function (child, index) {
        refsMoleculeSelectOptions[index] = _react2.default.createRef();
        return _react2.default.cloneElement(child, {
          innerRef: refsMoleculeSelectOptions[index],
          onSelectKey: keysSelection
        });
      });
    }
  }, {
    key: 'className',
    get: function get() {
      var focus = this.state.focus;
      var errorStateClass = this.errorStateClass;

      return (0, _classnames2.default)(BASE_CLASS, (0, _defineProperty3.default)({}, CLASS_FOCUS, focus), errorStateClass);
    }
  }, {
    key: 'errorStateClass',
    get: function get() {
      var errorState = this.props.errorState;

      if (errorState) return BASE_CLASS + '--' + ERROR_STATES.ERROR;
      if (errorState === false) return BASE_CLASS + '--' + ERROR_STATES.SUCCESS;
      return '';
    }
  }]);
  return MoleculeSelect;
}(_react.Component);

MoleculeSelect.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** The DOM id global attribute. */
  id: _propTypes2.default.string,

  /** if select accept single value or multiple values */
  multiselection: _propTypes2.default.bool,

  /** value selected */
  value: _propTypes2.default.any,

  /** list of values to be displayed on the select */
  options: _propTypes2.default.array,

  /** if list of options is displayed or not */
  isOpen: _propTypes2.default.bool,

  /** callback when arrow up/down is clicked → to show/hide list of options */
  onToggle: _propTypes2.default.func,

  /** callback to be triggered when value selected changes */
  onChange: _propTypes2.default.func,

  /** Icon for closing (removing) tags */
  iconCloseTag: _propTypes2.default.node.isRequired,

  /** Icon for arrow in select (down direction when closed) */
  iconArrowDown: _propTypes2.default.node.isRequired,

  /** size (height) of the list */
  size: _propTypes2.default.oneOf((0, _values2.default)(_reactMoleculeDropdownList.moleculeDropdownListSizes)),

  /** list of key identifiers that will trigger a selection */
  keysSelection: _propTypes2.default.array,

  /* object generated w/ Reacte.createRef method to get a DOM reference of internal input */
  refMoleculeSelect: _propTypes2.default.object,

  /** true = error, false = success, null = neutral */
  errorState: _propTypes2.default.bool
} : {} : {};

MoleculeSelect.defaultProps = {
  onChange: function onChange() {},
  onToggle: function onToggle() {},
  keysSelection: [' ', 'Enter']
};

exports.default = (0, _hoc.withOpenToggle)(MoleculeSelect);
exports.moleculeSelectDropdownListSizes = _reactMoleculeDropdownList.moleculeDropdownListSizes;